# -*- coding: utf-8 -*-

if __name__ == '__main__':
    # All kivy-related imports done inside the if __name__ to prevent parallel processes from creating new windows
    import sys
    sys.path.insert(0, './src')

    from kivy.config import Config
    from kivy.app import App
    from kivy.uix.screenmanager import ScreenManager

    from start_screen import StartScreen


    class MyApp(App):

        def build(self):
            self.icon = "media/icon.ico"
            self.title = "LiveSensing"
            sm = ScreenManager()
            sm.add_widget(StartScreen(name="start"))
            return sm


    # Three lines to ensure non-fullscreen, maximized window on launch
    Config.set('graphics', 'fullscreen', 0)
    Config.set('graphics', 'borderless', 0)
    Config.set('graphics', 'window_state', 'maximized')

    Config.write()

    app = MyApp()
    app.run()
