#ifndef GPS_H
#define GPS_H

#include "device.h"

/*
 * GPS class is the class handeling communication with the 
 * GPS receiver.
 */

class GPS : public Device
{
public:
	// default constructor
	GPS() : Device(){}
	void terminate_connection();
	int init_device(std::string path);
	//  searching for the packets in the byte stream from the GPS receiver
	int process_received_data();
	
private:
	// Extraction of the data for tranmission from original message
	bool extract_data_to_transfer(std::string & message);
	// Conversion of the string to the byte vector
	void convert_number_to_byte(std::string message, std::vector<uint8_t> & output, float sign);

	std::string __regex_key; // key used for recognition of the packet. It's value is set in the init_device to GPS_PACKET
};

#endif
