#ifndef LOGGER_H
#define LOGGER_H

#include <fstream>
#include <sstream>
#include <experimental/iterator>

#include "constants.h"

/*
 * Logger class handles storage of data in the raw format to the log file
 * Output string is in the utf-8.
 */

class Logger
{
public:
	// gets raw data from all peripherals and stores them into the log file in a row
	int log_data(std::vector<std::string> & to_log);
	int init_device(std::string path);
	void terminate_connection();
	
private:
	std::string __path; 		// path to log file
	std::ofstream __stream;		// output stream to file.
};

#endif
