	#ifndef MAGNETOMETER_H
#define MAGNETOMETER_H

#include "device.h"

/*
 * Magnetometer class handles communication with the magnetometer 
 * device.
 */

class Magnetometer : public Device
{
public:
	// default constructor
	Magnetometer() : Device(){}
	void terminate_connection();
	int init_device(std::string path);
	//  searching for the packets in the byte stream from the magnetometer
	int process_received_data();

private:
	// Extraction of the data for tranmission from original message
	bool extract_data_to_transfer(std::string & data);	
	// Conversion of the string to the byte vector
	void convert_number_to_byte(std::string message, std::vector<uint8_t> & output, float sign);

};

#endif
