#include "include/transmitter.h"
#include "include/receiver.h"


/* 
 * This is the entry point of the program
 * To switch between TRANSMITTER and RECEIVER mode, go to constants.h
 * Both modes can't be selected at the same time
 */
int main(int argc, char const *argv[])
{		
	(void)argc; (void)argv; // Werror flag satisfaction
#ifdef TRANSMITTER		
	Transmitter controller;
#elif RECEIVER	
	Receiver controller;
	std::thread __cmd_bridge(command_thread);
	std::thread __dat_bridge(data_thread);
	
	__cmd_bridge.detach();
	__dat_bridge.detach();
#endif
	
	if(controller.init_devices() != ERROR_SUCCESS)
	{
		std::cout << controller.get_error_message();
		return ERROR_FAILURE;
	}

	
	return controller.run_loop();
}
