# Script used for testing purposes, where no display of data is needed
import os
from threading import Thread

fifo_cmd = 'fifo_cmd'
fifo_dat = 'fifo_dat'


def command_thread():
	print('starting command thread')
	command = ""
	try:
		os.mkfifo(fifo_cmd)
	except OSError:
		os.remove(fifo_cmd)
		os.mkfifo(fifo_cmd)

	while command != "stop":
		command = input("send cmd: ")
		with open(fifo_cmd, 'w') as cmd:
			cmd.write(command)

	os.remove(fifo_cmd)
	print('closing command thread')

def data_thread():
	print('starting data thread')
	read = True
	data = ""
	try:
		os.mkfifo(fifo_dat)
	except OSError:
		os.remove(fifo_dat)
		os.mkfifo(fifo_dat)

	while read:
		with open(fifo_dat, 'r') as dat:
			for line in dat:
				print('received: ' + line)
				if line == 'None':
					read = False
	os.remove(fifo_dat)
	print('closing data thread')

if __name__ == "__main__":
	cmd_thread = Thread(target = command_thread)
	dat_thread = Thread(target = data_thread)

	cmd_thread.start()
	dat_thread.start()

	dat_thread.join()
	cmd_thread.join()

	print("finished")

