#include "../include/device.h"


/*
 * Tries to open specified port in /dev folder
 * If unsuccesful it returns ERROR_SERIAL_PORT_CLOSED
 */
int Device::open_port(std::string device, BAUD_RATE baud)
{
	__file_descriptor = serialOpen(device.c_str(),baud);
	if(__file_descriptor < 0)
	{
		__error_message = std::strerror (errno);
		std::cerr << __error_message << std::endl;
		return ERROR_SERIAL_PORT_CLOSED;
	}
	serialFlush(__file_descriptor);
	return ERROR_SUCCESS;
}

/* Returns whether there are some data in 
 * the buffer waiting to be received.
 * It can be both USB and GPIO UART buffer
 */ 
bool Device::data_available()
{
	return (serialDataAvail(__file_descriptor)) ? true : false; 
}

int Device::receive_data()
{
	while(serialDataAvail(__file_descriptor))
			__buffer.push_back(serialGetchar(__file_descriptor));
		
	return __buffer.size();
}

