#include "../include/logger.h"

/*
 * Initialize the file and stream writing to it
 * Path is by default Linux path to the log folder,
 * in the project folder followed by uniquely generated name. 
 */
int Logger::init_device(std::string path)
{
	__stream.open(path, std::ios::out);
	if(__stream.is_open())
	{
		__path = path;
		return ERROR_SUCCESS;
	}
	return ERROR_INIT_FAILED;
}


//Writing of the data to the file
int Logger::log_data(std::vector<std::string> & to_log)
{
	std::stringstream ss;
	std::copy(to_log.begin(),
              to_log.end(),
              std::experimental::make_ostream_joiner(ss, DATA_DELIMITER));

#ifdef DEBUG_LOG
	std::cout << "Logging: " << ss.str() << std::endl;
	std::cout << "Size of logged string: " << ss.str().size() << std::endl;
	std::cout << "Log stream status: " << __stream.good() << std::endl;
#endif
	__stream << ss.str() << std::endl;
	
	return ERROR_SUCCESS;
}


void Logger::terminate_connection()
{
	__stream.close();
}
