import matplotlib.pyplot as plt


class InteractivePlotter:
    """
    Generates an interactive plot using the default matplotlib backend.
    Since the plot blocks execution, this must be launched in a parallel thread or (preferably) process
    """
    def __init__(self, showing_trace, trace_data, linear_mode, contour_data):
        if showing_trace:
            plt.plot(trace_data[0], trace_data[1], 'kx-', markersize=0.5, linewidth=0.5)
        if linear_mode:
            plt.tricontourf(trace_data[0], trace_data[1], contour_data, levels=30)
        else:
            plt.contourf(contour_data[0], contour_data[1], contour_data[2], levels=30)
        plt.colorbar()
        plt.xlabel('Longitude (deg)')
        plt.ylabel('Latitude (deg)')
        # plt.title('Magnetic gradient (nT/m)')
        plt.show()
